/***************************************************************************
 *   Copyright (C) 2009 by Stanson   *
 *   stanson@btv.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef QOSCOPE_H
#define QOSCOPE_H

#include <usb.h>

#include <qwidget.h>
#include <qstring.h>

/**
	@author Stanson <stanson@btv.ru>
*/
class QOscope : public QWidget
{
Q_OBJECT
public:
    QOscope();
    ~QOscope();
    void initHardware();

public slots:
    void setTimescale( int );
    void setOffset( int );
    void setSync( int );

signals:
    void haveMessage( QString s );

protected:
    void paintEvent( QPaintEvent * );
    void timerEvent( QTimerEvent * );

private:
    usb_dev_handle *dev;
    unsigned char  data[256];
    unsigned char  pkt[64];
    int            timescale;
    int            offset;
    int            sync;
    QString        txt_scale;
};

#endif
